; main.asm
extern PerimeterRectangle
extern PerimeterTriangle
extern PerimeterShape
extern PerimeterSumContainer

global RECTANGLE
global TRIANGLE

extern	printf   ; declare the function as alien
section .data
    i       dd      10
    fmtstr  db      "%d -> %f",10,0     ; printf format
    pfmt    db      "Perimeter = %d, %f",10,0 ; printf format
    pcfmt   db      "Common Perimeter = %f",10,0 ; printf format
    RECTANGLE   dd  1
    TRIANGLE    dd  2
    shapeRect   dd  1
    rect    dd      5,7     ; прямоугольник с двумя сторонами
    empty   dd      0       ; пустое слово в фигуре для прямоугольника
    shapeTrian  dd  2
    trian   dd      3,4,5   ; три стороны треугольника
    ; Массив фигур
    cont    dd      1,2,3,0, 2,3,4,5, 1,2,8,0, 2,2,2,2, 2,5,7,4, 1,5,6,0
    len     dd      6
section .bss
    d       resq    1
    intP    resd    1       ; под целочисленное значение периметра
    p       resq    1       ; периметр как действительное
section .text
    global main
;----------------------------------------------
main:
    push    rbp
    mov     rbp,rsp

    mov     eax, [i]
    cvtsi2sd    xmm0, eax
    movsd [d], xmm0

    mov     rdi, fmtstr ; first argument for printf
    mov     rsi, [i]    ; second argument for printf
    movsd   xmm0, [d]   ; third argument for printf
    mov     rax, 1      ; xmm registers involved
    call    printf      ; call the function

    ; Вычисление периметра прямоугольника
    mov     rdi, rect
    call    PerimeterRectangle
    mov     [intP], eax
    movsd   [p], xmm0

    ; Вывод периметра прямоугольника
    mov     rdi, pfmt
    mov     rsi, rax
    movsd   xmm0, [p]   ; third argument for printf
    mov     rax, 1      ; only integer registers involved
    call    printf      ; call the function

    ; Вычисление периметра треугольника
    mov     rdi, trian
    call    PerimeterTriangle
    mov     [intP], eax
    movsd   [p], xmm0

    ; Вывод периметра треугольника
    mov     rdi, pfmt
    mov     rsi, rax
    movsd   xmm0, [p]   ; third argument for printf
    mov     rax, 1      ; only integer registers involved
    call    printf      ; call the function

    ; Вычисление периметра фигуры-прямоугольника
    mov     rdi, shapeRect
    call    PerimeterShape
    mov     [intP], eax
    movsd   [p], xmm0

    ; Вывод периметра фигуры-прямоугольника
    mov     rdi, pfmt
    mov     rsi, [intP]
    movsd   xmm0, [p]   ; third argument for printf
    mov     rax, 1      ; only integer registers involved
    call    printf      ; call the function

    ; Вычисление периметра фигуры-треугольника
    mov     rdi, shapeTrian
    call    PerimeterShape
    mov     [intP], eax
    movsd   [p], xmm0

    ; Вывод периметра фигуры-треугольника
    mov     rdi, pfmt
    mov     rsi, [intP]
    movsd   xmm0, [p]   ; third argument for printf
    mov     rax, 1      ; only integer registers involved
    call    printf      ; call the function

    ; Вычисление общего периметра 2-х фигур
    mov     rdi, shapeRect
    mov     rsi, 2
    call    PerimeterSumContainer
    movsd   [p], xmm0

    ; Вывод суммарного периметра 2-х фигур
    mov     rdi, pcfmt
    movsd   xmm0, [p]   ; third argument for printf
    mov     rax, 1      ; only integer registers involved
    call    printf      ; call the function

    ; Вычисление общего периметра нескольких фигур
    mov     rdi, cont
    mov     rsi, [len]
    call    PerimeterSumContainer
    movsd   [p], xmm0

    ; Вывод периметра нескольких фигур
    mov     rdi, pcfmt
    movsd   xmm0, [p]   ; third argument for printf
    mov     rax, 1      ; only integer registers involved
    call    printf      ; call the function

    pop     rbp
    mov     rax,60
    mov     rdi,0
syscall
